#!/usr/bin/env python

import getopt
import socket
import sys
import time

# Usage: ./probe.py probe_location dest_ip dest_port
#  E.g.: ./probe.py sitename 192.0.2.123 9001   

_, args = getopt.gnu_getopt(sys.argv[1:], "")
probe_location, HOST, PORT = args
PORT = int(PORT)

TIMEOUT = 30
family, socktype, proto, _, sockaddr = socket.getaddrinfo(HOST, PORT, 0, socket.SOCK_STREAM)[0]
s = socket.socket(family, socktype, proto)
s.settimeout(TIMEOUT)
timestamp = time.time()
connection_success = False
errno = ''
message = ''
try:
    s.connect(sockaddr)
    connection_success = True
except socket.error as E:
    errno = E.errno
    message = str(E)
endtime = time.time()

result = (timestamp, probe_location, HOST, PORT, endtime - timestamp, connection_success, errno, message)
print(','.join(str(x) for x in result))
